#!/usr/bin/python
import time, sys
try:
    from PyQt4.QtGui import *
    from PyQt4.QtCore import *
except Exception, e:
    print "Uh, oh, you seem to be missing PyQT4 !\nHave you tried 'apt-get install python2.5-qt4-gui' ?"
    exit()

class GraphWidget(QGraphicsView):
    def __init__(self):
        QGraphicsView.__init__(self)

        self.timerId = 0

        scene = QGraphicsScene(self)
        scene.setItemIndexMethod(QGraphicsScene.NoIndex)
        self.setScene(scene)
        self.setCacheMode(QGraphicsView.CacheBackground)
        self.setRenderHint(QPainter.Antialiasing)
        self.setTransformationAnchor(self.NoAnchor)
        self.setResizeAnchor(QGraphicsView.AnchorViewCenter)
        lines = []
        self.offset = 0.0
        self.bigline = 5
        text = open("lorem.txt", "r").readlines()
        font = QFont("verdana", 18)
        print font
        fm = QFontMetrics(font)
        self.h = float(fm.height())
        print self.h
        print fm
        for part in text:
            words = part.split()
            line = ''
            for word in words:
                w = fm.width(QString("%s %s" % (line, word)))
                if w > 450:
                    lines.append(line)
                    line = ''
                else:
                    line += " " + word

        self.timer = QTimeLine(1000);
        self.timer.setFrameRange(0, 10);
        self.gtis = []
        for idx, line in enumerate(lines):
            gti = scene.addSimpleText(QString(line), font)
            gti.setPos(float(idx*self.h), 480.0)
            gti.rotate(270)
            self.gtis.append(gti)

        self.scale(1.0, 1.0)
        self.setMinimumSize(800, 480)
        self.connect(self.timer, SIGNAL("valueChanged(qreal)"), lambda x: self.resetTransform() or self.translate(-self.h*x - self.offset, 0.0))

def again(widget):
    widget.offset += widget.h
    time.sleep(1)
    print "go"
    widget.timer.start()

if __name__ == "__main__":
    app = QApplication(sys.argv)
    qsrand(QTime(0,0,0).secsTo(QTime.currentTime()))

    widget = GraphWidget()
    widget.show()

    widget.timer.start()
    app.connect(widget.timer, SIGNAL("finished()"), lambda: again(widget))

    sys.exit(app.exec_())
